<?php

/* include api class, include path in "admin" mode differs from "shop" mode */
if (function_exists('tep_catalog_href_link')) {
	require_once("../includes/languages/german/modules/payment/secupay_kk_osc.php");
	require_once("../" . DIR_WS_CLASSES . 'secupay_api.php');
	require_once("../sp_conf_kk.php");
} else {
	require_once(DIR_WS_CLASSES . 'secupay_api.php');
	require_once("sp_conf_kk.php");
}

class secupay_kk_osc {

	var $code, //name of the module
		$title, //title name in list
		$description,
		$enabled,
		$iframe,
		$history_id,
		$sp_log,
		$conf;

	function secupay_kk_osc() {
		// class constructor
		global $order;

		$this->code = 'secupay_kk_osc';
		$this->title = (function_exists('tep_catalog_href_link')) ? MODULE_PAYMENT_SPKK_TEXT_TITLE . "<br/><img style='border:0;text-decoration:none;' alt='secupay logo' src='images/secupay_label_24.png'/>" : MODULE_PAYMENT_SPKK_TEXT_TITLE;
		$this->sort_order = MODULE_PAYMENT_SPKK_SORT_ORDER;
		$this->enabled = strcmp(MODULE_PAYMENT_SPKK_STATUS, 'Ja') == 0 ? true : false;
		$this->sp_log = false;
		//Demo Modus
		if (strcmp(MODULE_PAYMENT_SPKK_SIMULATION_MODE, "Simulation") == 0) {
			$this->demo = true;
		} else {
			$this->demo = false;
		}

		$this->conf =get_sp_conf_kk();

		if ((int) MODULE_PAYMENT_SPKK_ORDER_STATUS_ID > 0) {
			$this->order_status_success = MODULE_PAYMENT_SPKK_ORDER_STATUS_ID;
		}

		$this->description = MODULE_PAYMENT_SPKK_TEXT_DESCRIPTION . "<br/>Version " . $this->conf->modulversion .
			" - <a style='color:green;' href='https://connect.secupay.ag/' target='_blank'>secupay Login</a>" .
			" - <a style='color:green;' href='http://www.secupay.ag/' target='_blank'>secupay Website</a>";
		$this->description.='<iframe frameborder="0" scrolling="auto" src="https://connect.secupay.ag/shopiframe.php?vertrag_id_kk=' . MODULE_PAYMENT_SPKK_VERTRAG_ID . '&amp;shop=osc&amp;shopversion=' . urlencode(PROJECT_VERSION) . '&amp;modulversion=' . $this->conf->modulversion . '" marginwidth="0px" marginheight="0px" name="secupay_info" style="border:0px; display:block;width:98%;margin-top:3px;margin-bottom:3px;"></iframe>';

		if (MODULE_PAYMENT_SPKK_LOGGING == "Ja") {
			$this->sp_log = true;
		}
		secupay_log($this->sp_log, 'kk', "secupay_kk_osc constructor php " . PHP_VERSION);
		secupay_log($this->sp_log, "conf: " . json_encode($this->conf));
		secupay_log($this->sp_log, "Modus: " . MODULE_PAYMENT_SPKK_SIMULATION_MODE);
		secupay_log($this->sp_log, "Sort Order: " . MODULE_PAYMENT_SPKK_SORT_ORDER);
		secupay_log($this->sp_log, "Aktiv: " . MODULE_PAYMENT_SPKK_STATUS);
		secupay_log($this->sp_log, "Kuferschutz: " . MODULE_PAYMENT_SPKK_KAEUFERSCHUTZ);
		secupay_log($this->sp_log, "Zahlungsgarantie: " . MODULE_PAYMENT_SPKK_GUARANTEE);
		secupay_log($this->sp_log, "Order Status erfolg: " . MODULE_PAYMENT_SPKK_ORDER_STATUS_ID);

		if (is_object($order))
			$this->update_status();
	}

	function update_status() {
		global $order;
		secupay_log($this->sp_log, "update_status");

		if (($this->enabled == true) && ((int) MODULE_PAYMENT_SPKK_ZONE > 0)) {
			$check_flag = false;
			$check_query = tep_db_query("select zone_id from " . TABLE_ZONES_TO_GEO_ZONES . " where geo_zone_id = '" . MODULE_PAYMENT_SPKK_ZONE . "' and zone_country_id = '" . $order->billing['country']['id'] . "' order by zone_id");
			while ($check = tep_db_fetch_array($check_query)) {
				if ($check['zone_id'] < 1) {
					$check_flag = true;
					break;
				} elseif ($check['zone_id'] == $order->billing['zone_id']) {
					$check_flag = true;
					break;
				}
			}

			if ($check_flag == false) {
				$this->enabled = false;
			}
		}
	}

	function javascript_validation() {
		return '';
	}

	function selection() {
		secupay_log($this->sp_log,"selection");
		global $order;
		unset($_SESSION['iframe_link']);
		unset($_SESSION['sp_success']);
		$vert=MODULE_PAYMENT_SPKK_VERTRAG_ID;
		$schutz="";
		$title = $this->title;

		$schutz="";
		$title = $this->title;

		if (MODULE_PAYMENT_SPKK_GUARANTEE == "Ja" && MODULE_PAYMENT_SPKK_KAEUFERSCHUTZ == "Ja") {
			$schutz = "<a href=\"#\" style='border=0; text-decoration=0;' onclick=\"window.open('https://connect.secupay.ag/kaeuferschutz.php?v=$vert',null,'width=500,height=260,scrollbars=no,location=no,directories=no,status=no,menubar=no,toolbar=no,resizable=no,dependent=no');return false;\" ><img alt=\"secupay.Kuferschutz\" style=\"border:0;\" src=\"images/secupay_100x100.png\" /></a>";
			$title = $this->title . "&nbsp;<a style=\"color:green;\" href=\"#\" onclick=\"window.open('https://connect.secupay.ag/kaeuferschutz.php?v=$vert',null,'width=500,height=260,scrollbars=no,location=no,directories=no,status=no,menubar=no,toolbar=no,resizable=no,dependent=no');return false;\">mit secupay K&auml;uferschutz</a>";
			$selection = array('id' => $this->code, 'module' => $title,
				'fields' => array(array('title' => "<iframe frameborder=0 style='border:0;scroll:auto; width:500px;height:265px;' src='https://connect.secupay.ag/kaeuferschutz.php?v=$vert&close=false'></iframe>", 'field' => $schutz))
			);
		}else{
			$selection = array('id' => $this->code, 'module' => $title,
				'fields' => array(array('field' => $schutz))
			);
		}

		secupay_log($this->sp_log, $selection);
		return $selection;
	}

	function check() {
		if (!isset($this->_check)) {
			$check_query = tep_db_query("select configuration_value from " . TABLE_CONFIGURATION . " where configuration_key = 'MODULE_PAYMENT_SPKK_STATUS'");
			$this->_check = tep_db_num_rows($check_query);
		}
		secupay_log($this->sp_log, "check($this->_check)");
		return $this->_check;
	}

	function pre_confirmation_check() {
		secupay_log($this->sp_log, "pre_confirmation_check");
	}

	function confirmation() {
		global $order;
		secupay_log($this->sp_log, "confirmation");

		$confirmation = array('title' => $this->title, 'fields' => array());

		if (isset($order->delivery) && MODULE_PAYMENT_SPKK_GUARANTEE == "Ja" && MODULE_PAYMENT_SPKK_WARNDELIVERY == "Ja") {
			$differs = false;
			if ($order->delivery['firstname'] !== $order->customer['firstname']) {
				$differs = true;
			}
			if ($order->delivery['lastname'] !== $order->customer['lastname']) {
				$differs = true;
			}
			if ($order->delivery['company'] !== $order->customer['company']) {
				$differs = true;
			}
			if ($order->delivery['city'] !== $order->customer['city']) {
				$differs = true;
			}
			if ($order->delivery['postcode'] !== $order->customer['postcode']) {
				$differs = true;
			}
			if ($order->delivery['street_address'] !== $order->customer['street_address']) {
				$differs = true;
			}
			if ($differs) {
				$additional_messages = array('title' => MODULE_PAYMENT_SPKK_HINT, 'field' => MODULE_PAYMENT_SPKK_DELIVERY_HINT);
				$confirmation['fields'][] = $additional_messages;
			}
		}
		return $confirmation;
	}

	function process_button() {
		global $order;
		$process_button_string = tep_draw_hidden_field('summe_aus_button', number_format($order->info['total'], 2, '.', ''));
		secupay_log($this->sp_log, "process_button", $_POST, "summe_aus_button: " . number_format($order->info['total'], 2, '.', ''));
		return $process_button_string;
	}

	function before_process() {
		global $order, $xtPrice, $insert_id;
		secupay_log($this->sp_log, "before_process start");
		if (!isset($_SESSION['sp_success'])) {
			secupay_log($_SESSION);
			secupay_log($this->sp_log, "before_process KK sp_success ist leer in session");
			//Daten vorbereiten
			$next_order_id = $this->_get_next_order_id();
			secupay_log($this->sp_log, "before_process next_order_id $next_order_id");

			$_mwst_bug = 0;
			if (MODULE_PAYMENT_SPKK_MWST == "Ja") {
				$_mwst_bug = ($order->info['shipping_cost'] * (19 / 100));
			}

			secupay_log($this->sp_log, "mwst_bug $_mwst_bug");

			$amount = $_REQUEST['summe_aus_button'] + $_mwst_bug;

			secupay_log($this->sp_log, "amount $amount");
			secupay_log($this->sp_log, "before_process, summe: " . number_format($order->info['total'], 2, '.', ''));

			$dob_res = tep_db_query("select customers_dob from " . TABLE_CUSTOMERS . " where customers_id=" . $_SESSION['customer_id']);
			if ($dob_res && $dob_row = tep_db_fetch_array($dob_res)) {
				$daten['geburts_datum'] = $dob_row['customers_dob'];
			}

			if (empty($store_name)) {
				$res_store_name = tep_db_query("select configuration_value from configuration where configuration_key='STORE_NAME'");
				$row_store_name = tep_db_fetch_array($res_store_name);
				$store_name = $row_store_name['configuration_value'];
			}
			$data = Array();
			$data['basket'] = json_encode(get_object_vars($order));
			$data['apikey'] = MODULE_PAYMENT_SPKK_VERTRAG_ID;
			$data['shop'] = "osc";
			$data['shopversion'] = PROJECT_VERSION;
			$data['modulversion'] = $this->conf->modulversion;	
			$data['amount'] = $amount * 100;

			$data['apiversion'] = "1.0";

			if($_SESSION['language'] == "english") {
         	$data['language'] = 'EN';
			} else {
         	$data['language'] = 'DE';
         }

			$spuid = md5(uniqid(mt_rand()));
			$_SESSION['spuid']=$spuid;
			$data['url_success'] = tep_href_link('secupay_checkout_success.php', 'spuid='.$spuid, 'SSL', true, false);
			$data['url_failure'] = tep_href_link('secupay_checkout_failure.php', '', 'SSL');

			$data['purpose'] = "Bestellung vom " . date("d.m.y", time()) . "|bei " . $store_name . "|Bei Fragen TEL 035955755055";

			if ($this->demo) {
				$data['demo'] = 1;
			}

			$data['firstname'] = $order->customer['firstname'];
			$data['lastname'] = $order->customer['lastname'];
			$data['street'] = $order->customer['street_address'];
			$data['zip'] = $order->customer['postcode'];
			$data['city'] = $order->customer['city'];
			$data['email'] = $order->customer['email_address'];
			$data['company'] = $order->customer['company'];
			$data['telephone'] = $order->customer['telephone'];

			$data['ip'] = $_SERVER['REMOTE_ADDR'];

			$secure_code= md5(MODULE_PAYMENT_SPKK_VERTRAG_ID . time());
			$data['secure_code'] = $secure_code;

			if (MODULE_PAYMENT_SPKK_BID == "Ja") {
				$data['status_uri'] = HTTP_SERVER . DIR_WS_CATALOG . "secupay_status.php";
			}

			if (MODULE_PAYMENT_SPKK_GUARANTEE == "Ja") {
				$sp_api = new secupay_api($data, "iframeguarantee", "json");
			} else {
				$sp_api = new secupay_api($data, "iframe", "json");
			}

			secupay_log($this->sp_log, $data);
			$api_return = $sp_api->request();

			secupay_log($this->sp_log, $api_return);
			$log_amount = $amount * 100;
			$this->history_id = $this->_prepare_trans_log(htmlentities(json_encode($data),ENT_QUOTES), htmlentities(json_encode($api_return),ENT_QUOTES), htmlentities($api_return->transaction_id,ENT_QUOTES), $next_order_id, htmlentities($api_return->msg,ENT_QUOTES), htmlentities($api_return->status,ENT_QUOTES), $log_amount, $secure_code);
			secupay_log($this->sp_log, "before_process history_id:direkt nach function call ",$this->history_id);
			secupay_log($this->sp_log, "history_id nach aufruf prepare", $this->history_id);
			if ($api_return->status != "201") { //Fehler
				$error = utf8_decode($api_return->msg_user);
				$payment_error_return = 'payment_error=' . $this->code . '&error=' . urlencode($error);
				tep_redirect(tep_href_link(FILENAME_CHECKOUT_PAYMENT, $payment_error_return, 'SSL', true, false));
			} else {
				$this->iframe = $api_return->iframe;
				$_SESSION['sp_transaction_id'] = $api_return->transaction_id;
				$_SESSION['iframe_link'] = stripslashes($api_return->iframe);
				$_SESSION['sp_amount'] = $amount * 100;
				tep_redirect(tep_href_link("secupay_checkout_iframe.php", "", 'SSL', true, false));
			}

			die("Fehler aufgetreten");
		}
		if(isset($_SESSION['sp_success'] ) && $_SESSION['sp_success'] == false){
			unset($_SESSION['sp_success']);

			$daten = array();

			secupay_log($this->sp_log, "before_process, transaction failure: ", json_encode($_REQUEST));

			$daten['success'] = 0;
			$daten['transaction_id'] = $_SESSION['sp_transaction_id'];
			$daten['apikey'] = MODULE_PAYMENT_SPKK_VERTRAG_ID;
			$daten['amount'] = $_SESSION['sp_amount']; //$fPrice * 100;
			$daten['result'] = json_encode($_REQUEST);

			secupay_log($this->sp_log, "before_process, iframe commit", json_encode($daten));
			$sp_api = new secupay_api($daten, "iframecapture");
			$sp_api->request();

			$error=$_REQUEST['error'];
			$payment_error_return = 'payment_error=' . $this->code . '&error=' . urlencode($error);
			tep_redirect(tep_href_link(FILENAME_CHECKOUT_PAYMENT, $payment_error_return, 'SSL', true, false));
			die();
		}
		secupay_log($this->sp_log, "before_process session sp_success true & unset");
		unset($_SESSION['sp_success']);
	}

	function after_process() {
		global $insert_id		;
		secupay_log($this->sp_log, "after_process insert_id $insert_id");
		secupay_log($this->sp_log, "history_id " . $_SESSION['history_id']);
		tep_db_query("UPDATE secupay_history_kk SET ordernr = $insert_id where log_id = " . $_SESSION['history_id']);
		$paymethod = $this->code;
		if ($this->demo == true) {
			$paymethod .= MODULE_PAYMENT_SPKK_DEMO_HINT;
		}
		$sql_data_array = array('orders_id' => (int) $insert_id,
			'orders_status_id' => (int) $this->order_status_success, //(int)$order->info['order_status'],
			'date_added' => 'now()',
			'customer_notified' => '0',
			'comments' => $paymethod);

		tep_db_perform(TABLE_ORDERS_STATUS_HISTORY, $sql_data_array);

		if ($this->order_status_success)
			tep_db_query("UPDATE " . TABLE_ORDERS . " SET orders_status='" . $this->order_status_success . "' WHERE orders_id='" . $insert_id . "'");
	}

	function get_error() {
		$fehler = $_GET['error'];
		secupay_log($this->sp_log, "get_error ($fehler)");
		$error = array('title' => MODULE_PAYMENT_SPKK_TEXT_ERROR, 'error' => stripslashes(urldecode($fehler)));
		return $error;
	}

	function install() {
		secupay_log($this->sp_log, "install");
		$pref = "insert into " . TABLE_CONFIGURATION . " ( configuration_title,configuration_description, configuration_key, configuration_value,  configuration_group_id, sort_order,";

		if ($this->conf->vertrag_id && is_string($this->conf->vertrag_id)) {
			$vertrag_id_kk = trim($this->conf->vertrag_id);
		}

		$modus = $this->conf->modus == "live" ? "Produktivsystem" : "Simulation";
		$debug = $this->conf->debug ? 'Ja' : 'Nein';
		$kaeuferschutz = $this->conf->kaeuferschutz ? 'Ja' : 'Nein';
		$zg = $this->conf->zahlungsgarantie ? 'Ja' : 'Nein';
		$lw = $this->conf->lieferanschrift_warnung ? 'Ja' : 'Nein';
		$modul = $this->conf->modul;

		tep_db_query("$pref set_function, date_added) values ('" . MODULE_PAYMENT_SPKK_STATUS_TITLE . "','" . MODULE_PAYMENT_SPKK_STATUS_DESC . "', 'MODULE_PAYMENT_SPKK_STATUS', 'Ja', '6', '0', 'tep_cfg_select_option(array(\'Ja\', \'Nein\'), ', now())");
		tep_db_query("$pref date_added) values ('" . MODULE_PAYMENT_SPKK_SORT_ORDER_TITLE . "','" . MODULE_PAYMENT_SPKK_SORT_ORDER_DESC . "', 'MODULE_PAYMENT_SPKK_SORT_ORDER', '0',  '6', '0' , now())");
		tep_db_query("$pref date_added) values ('" . MODULE_PAYMENT_SPKK_VERTRAG_ID_TITLE . "','" . MODULE_PAYMENT_SPKK_VERTRAG_ID_DESC . "', '" . MODULE_PAYMENT_SPKK_VERTRAG_ID . "', '{$vertrag_id_kk}',  '6', '0' , now())");
		tep_db_query("$pref use_function, set_function, date_added) values ( '" . MODULE_PAYMENT_SPKK_ZONE_TITLE . "','" . MODULE_PAYMENT_SPKK_ZONE_DESC . "', 'MODULE_PAYMENT_SPKK_ZONE', '0',  '6', '2', 'tep_get_zone_class_title', 'tep_cfg_pull_down_zone_classes(', now())");
		tep_db_query("$pref set_function, use_function, date_added) values ('" . MODULE_PAYMENT_SPKK_ORDER_STATUS_ID_TITLE . "','" . MODULE_PAYMENT_SPKK_ORDER_STATUS_ID_DESC . "', 'MODULE_PAYMENT_SPKK_ORDER_STATUS_ID', '0',  '6', '0', 'tep_cfg_pull_down_order_statuses(', 'tep_get_order_status_name', now())");

		tep_db_query("$pref set_function, date_added) values ( '" . MODULE_PAYMENT_SPKK_SIMULATION_MODE_TITLE . "','" . MODULE_PAYMENT_SPKK_SIMULATION_MODE_DESC . "', 'MODULE_PAYMENT_SPKK_SIMULATION_MODE', '$modus', '6', '0', 'tep_cfg_select_option(array(\'Simulation\', \'Produktivsystem\'), ', now())");
		tep_db_query("$pref set_function, date_added) values ( '" . MODULE_PAYMENT_SPKK_MWST_TITLE . "','" . MODULE_PAYMENT_SPKK_MWST_DESC . "', 'MODULE_PAYMENT_SPKK_MWST', 'Nein', '6', '0', 'tep_cfg_select_option(array(\'Ja\', \'Nein\'), ', now())");
		tep_db_query("$pref set_function, date_added) values ( '" . MODULE_PAYMENT_SPKK_LOGGING_TITLE . "','" . MODULE_PAYMENT_SPKK_LOGGING_DESC . "', 'MODULE_PAYMENT_SPKK_LOGGING','$debug', '6', '0', 'tep_cfg_select_option(array(\'Ja\', \'Nein\'), ', now())");
		tep_db_query("$pref set_function, date_added) values ( '" . MODULE_PAYMENT_SPKK_WARNDELIVERY_TITLE . "','" . MODULE_PAYMENT_SPKK_WARNDELIVERY_DESC . "', 'MODULE_PAYMENT_SPKK_WARNDELIVERY', '$lw', '6', '0', 'tep_cfg_select_option(array(\'Ja\', \'Nein\'), ', now())");
		tep_db_query("$pref set_function, date_added) values ('" . MODULE_PAYMENT_SPKK_KAEUFERSCHUTZ_TITLE . "','" . MODULE_PAYMENT_SPKK_KAEUFERSCHUTZ_DESC . "',  'MODULE_PAYMENT_SPKK_KAEUFERSCHUTZ', '$kaeuferschutz', '6', '0', 'tep_cfg_select_option(array(\'Ja\', \'Nein\'), ', now())");
		tep_db_query("$pref set_function, date_added) values ('" . MODULE_PAYMENT_SPKK_GUARANTEE_TITLE . "','" . MODULE_PAYMENT_SPKK_GUARANTEE_DESC . "',  'MODULE_PAYMENT_SPKK_GUARANTEE', '$zg', '6', '0', 'tep_cfg_select_option(array(\'Ja\', \'Nein\'), ', now())");
		tep_db_query("$pref set_function, date_added) values ('" . MODULE_PAYMENT_SPKK_BID_TITLE . "','" . MODULE_PAYMENT_SPKK_BID_DESC . "',  'MODULE_PAYMENT_SPKK_BID', 'Ja', '6', '0', 'tep_cfg_select_option(array(\'Ja\', \'Nein\'), ', now())");

		tep_db_query("drop table if exists secupay_history_kk");
		tep_db_query("create table secupay_history_kk (`log_id` int(10) unsigned not null auto_increment,
			`req_data` text,
			`ret_data` text,
			`payment_method` varchar(255) default null,
			`transaction_id` int(10) unsigned default null,
			`ordernr` int(11) default null,
			`msg` varchar(255) default null,
			`rank` int(10) default null,
			`status` int(11) default null,
			`amount` varchar(255) default null,
			`action` text,
			`secure_code` text,
			`created` datetime not null,
			`timestamp` timestamp,
			primary key  (`log_id`)) auto_increment=1 default charset=latin1");
	}

	function remove() {
		secupay_log($this->sp_log, "remove");
		tep_db_query("delete from " . TABLE_CONFIGURATION . " where configuration_key in ('" . implode("', '", $this->keys()) . "','MODULE_PAYMENT_SECUPAY_KK_OSC_ALLOWED')");
	}

	function keys() {
		$keys = array(	
			'MODULE_PAYMENT_SPKK_STATUS',
			'MODULE_PAYMENT_SPKK_VERTRAG_ID',
			'MODULE_PAYMENT_SPKK_GUARANTEE',
			'MODULE_PAYMENT_SPKK_SORT_ORDER',
			'MODULE_PAYMENT_SPKK_KAEUFERSCHUTZ',
			'MODULE_PAYMENT_SPKK_WARNDELIVERY',
			'MODULE_PAYMENT_SPKK_SIMULATION_MODE',
			'MODULE_PAYMENT_SPKK_LOGGING',
			'MODULE_PAYMENT_SPKK_ZONE',
			'MODULE_PAYMENT_SPKK_ORDER_STATUS_ID',
			'MODULE_PAYMENT_SPKK_MWST',
			'MODULE_PAYMENT_SPKK_BID'
		);
		secupay_log($this->sp_log, "keys", $keys);
		return $keys;
	}

	//intern verwendete Methoden
	function _get_next_order_id() {
		$qry = tep_db_query('SELECT max(orders_id) + 1 next_id from ' . TABLE_ORDERS);
		$res = tep_db_fetch_array($qry);

		if (!$res['next_id']) {
			return 1;
		} else {
			return $res['next_id'];
		}
	}

	function _prepare_trans_log($req_data, $ret_data, $transaction_id, $ordernr, $msg, $status, $amount, $secure_code) {
		global $sp_history_id;
		$sql = "insert into secupay_history_kk (req_data, ret_data,payment_method,transaction_id, ordernr, msg,rank,status,amount,action,secure_code,created)" .
			" values ('".tep_db_input($req_data)."','".tep_db_input($ret_data)."','".tep_db_input($this->code)."','".tep_db_input($transaction_id)."','".tep_db_input($ordernr)."','".tep_db_input($msg)."',0,'".tep_db_input($status)."',".tep_db_input($amount).",'','".tep_db_input($secure_code)."',NOW())";
		$qry = tep_db_query($sql);
		$iid = tep_db_insert_id();
		$sp_history_id = $iid;
		$_SESSION['history_id'] =$sp_history_id;
		secupay_log($this->sp_log, "history_id, insert_id:", $iid);

		return $iid;
	}
}
